<?php



	/******************************************\
	* Web Application 4.0 by SCFDuffy (C) 2021 *
	* ---------------------------------------- ********************\
	* SCFDuffy retains the absolute copyright on this source code. *
	* This includes portions written in PHP, SQL, CSS, Javascript, *
	* HTML and any prosaic writings contained in this file. It may *
	* not be copied, clipped, modified or published in whole or in *
	* part without the expressed prior consent of SCFDuffy. These  *
	* rights of copy are retained to the fullest extent applicable *
	* in law. All Rights Reserved. (C) Copyright SCFDuffy 2021 (C) *
	* ------------------------------------------------------------ *
	* Web Application 4.0 Installer by SCFDuffy - (C)February 2021 *
	\**************************************************************/



	require_once('../classes/Application.php');
	$app=new Application();
	$app->renderHead("Code of Conduct - {$app->sitename}",'SCFDuffy',"Code of Conduct, Rules, Bans, Banning, Moderation, Moderator, Behaviour, Etiquette, Community","The Code of Conduct for members of {$app->sitename}");
	$app->renderHeader();
?>
<h1>Code of Conduct</h1>
<article>
	<h1>The Law</h1>
	<section>
		<h1>Code of Conduct</h1>
		<blockquote style='text-align:center;'>Treat others in the same way you wish to be treated.</blockquote>
		<p style='text-align:right;'>Simples!</p>
	</section>
	<section>
		<h3>In greater depth</h3>
		<p>One of the greatest causes of unhappiness is man's inhumanity to man.
		It is hard to say how <q>The Law</q> came about since it seems to have
		existed in the earliest recorded histories suggesting that the concept of
		this thing we call <q>The Law</q> is not essentially a legislated written
		thing but a way of life which is suggested as a wise thing for a people to
		live by.
		</p>
		<p>When we refer to <q>The Law</q> in this way, we do not mean the rules
		and regulations, statutes and ordinances of a state, organisation or body
		politic but something which to us seems self-evidently fundamental to such
		types of <i>law</i> that it is a startling awakening when we first learn
		that with this type of <i>law</i> there are practices so departed from the
		very notion of justice that they ought not to be called <i>law</i> event
		though this is exactly what their makers, enforcers and judges would call
		them.
		</p>
		<p>We are an online community and while we hope people will get along with
		one another, this is not a state of affairs we expect will ever actually
		exist, so we have some rules that members must follow in order to avoid a
		ban from the use of the site.
		</p>
		<p>These rules are not <q>The Law</q> but a system which regulates the
		community so as to ensure no one causes a breach of the law without either
		reparition to the injured party or suffering a penalty for failing to do
		so.
		</p>
		<p>The concept of <q>The Law</q> as described in the simple top section to
		this page is a very important thing for our members to understand and live
		by whilst engaging in our online community. The rules only come into play
		when there is a question of whether <q>The Law</q> has been broken or once
		it has been determinned that there has been a breach in <q>The Law</q>.
	</section>
	<section>
		<h3>The Rules</h3>
		<p>1. We are all equal before the law and no member shall be deemed to be
		in breach of the law for engaging in activites that cause no injury to
		another member.
		</p>
		<p>2. An injury shall have occurred if a member acts in a way which has 
		affect on another member which the member so acting would themselve deem
		to be injurious if the act they committed was carried out against the
		member who acted.
		</p>
		<p>3. In the case of an injurious act carried out by a member against a
		member in response to an earlier injurious act by member sustaining later
		injury from the responding member then the later injury will be judged on
		the merits of proportionality and the earlier injury will be treated as a
		breach of the law to likewise ruled on. In the case of a chain of injuries
		by members injuring one another, the member (or members) who started the
		injurious chain of events shall repair the damage to the extent possible
		discounting from this any acts of improportionality from the reparitions
		which are due.
		</p>
		<p>4. Failure to repair the damage by the injury initiating member will
		result in a penalty being applied even if such failure comes about as a
		result of the member being unable to repair the injury which has been
		caused.
		</p>
		<p>5. Should a member who initiates injury repair the damage their injury
		have caused then any member who responded injuriously shall be required
		or repair the damage they have caused or a penalty shall be applied to
		them.
		</p>
		<p>6. A breach of the law may be reported to a member of staff by anyone
		witnessing such a breach using the mechanisms provided by the software.
		</p>
		<p>7. The member of staff who deals with the report shall convene a carry
		out a determination on whether the reported member broke the law or not.
		</p>
		<p>8. If it is determinned that the member did break the law then a member
		of staff will inquire into the injuries sustained by the injured party and
		call on the guilty member to repair the damage.
		</p>
		<p>9. If a guilty member repairs the injury, or makes way toward doing so
		in a reasonable amount of time then the breach of the law will be deemed
		repaired and the guilty member will be considered innocent again.
		</p>
		<p>10. If a guilty member unreasonably refuses to repair the injury or is
		incapable of repairing the injuring or sets out to repair the injury but
		at such miniscule effort that it is unlikely the injury will be repaired,
		then the guilty member shall have a penalty applied.
		</p>
	</section>
	<section>
		<h3>The Penalties</h3>
		<p>Although the victim of a member who has broken the law causing injury
		they will not repair may have a sense of vindication in absence of the
		desired reparition, the purpose of penalties is not to make the victim
		feel better but to protect the online community from self-injury. Thus the
		penalties are applied in regards to what are in the best interests of the
		community and is a matter of executive decision for the staff according to
		their rank and the circumstances in which a penalty is to be imposed.
		</p>
		<p>Under this code of conduct, penalties are limited to bans for a variety
		of periods of time. In the case of a member who is a paying member, if a
		ban is to be imposed	lasting more than a day, the member is entitled to
		either a refund or a discount on their next payment taking into account
		the days they have no had access due to the ban. It does not matter that
		they have caused irreparable injury or the extent of the guilt in the
		matter which they are to be penalised for. If they are not permanently
		banned over a very grevious matter then we expect them to return and the
		penalty is the ban itself and it would be injurious of ourselves to charge
		the member for time in which they did not have access to the online
		community. The default position is a discount on the next subscription fee
		for the member but a partial refund should not be unreasonably refused if
		the member so requests. Bear in mind that there are transaction costs in
		both receiving subscriptions and paying refunds and these should be taken
		into account in determinning the amount of discount or refund which is
		applicable. In no circumstances should these transaction costs be borne by
		the site since they have arose through the actions of the member found to
		be in breach of the law.
		</p>
	</section>
	<section>
		<h3>For Legal Professionals</h3>
		<p>The Law, as referred to on this page does not infer any connection with
		municipal, state, federal or international, ecuminical type of law but is
		merely an expression of a moral precept which may or may not overlap with
		various bodies of law that the legal profession find themself dealing with
		in a professional capacity. This Code of Conduct has not been written by a
		lawyer nor is it intended convey the sense of the word <i>law</i> which
		may come up in the jurisdiction of judiciary of a nation state or similar.
		</p>
	</section>
</article>
<?php
	$app->renderFooter();
	$app->renderTail();
?>
